# Entaxy features install

### Alternative languages

[Russian](README.ru.md)

### Introduction

You need several steps for Entaxy features installation.
Use Java 11+.

### Build
You will need to compile this example first:

	mvn install

### Run

To run the example on Apache Karaf 4.x or newer

#### Step 1: Karaf

Launch the server

	karaf / karaf.bat


#### Step 2: DB Setup

If use docker:

    docker run --name entaxy_db -p 5432:5432 -e POSTGRES_PASSWORD=entaxy -e POSTGRES_USER=entaxy -e POSTGRES_DB=cache -d postgres

#### Step 3: Add features

Add features required

	feature:repo-add mvn:ru.entaxy.esb/karaf-features/LATEST/xml/features
	feature:install liquibase-updater
	feature:install entaxy-esb-api

Install nsi

	feature:install nsi
		
Install permission

	feature:install permission	
		
Install system-registry

	feature:install system-registry
	
Install system-group-registry

	feature:install system-group-registry
	
Install system-group-profile

	install -s blueprint:mvn:ru.entaxy.esb.integration.esb.test.profiles/test-profiles/1.0-SNAPSHOT/xml/g_test
    
Install bridge

    feature:install bridge
    
Install basic-auth

    feature:install basic-auth
    
Install events

    feature:install events
	
Useful comand for dev

	bundle:watch mvn:ru.entaxy.esb/nsi-esb/1.0-SNAPSHOT

#### Step 4: Verify that your service is available using the following url in the browser.

We assume you're using Karaf's default PAX Web configuration which uses port `8181` for http. If you would like to use another port or https, change the configuration in `${KARAF_HOME}/etc/org.ops4j.pax.web.cfg`. The immediate extension after the hostname and port ("cxf" in the below URL) is configured via the org.apache.cxf.osgi.cfg file (Please see [http://team.ops4j.org/wiki//display/paxweb/Pax+Web](http://team.ops4j.org/wiki//display/paxweb/Pax+Web) for more information on PAX Web).

[http://localhost:8181/cxf/xdto/NSI?wsdl](http://localhost:8181/cxf/xdto/NSI?wsdl)

#### Step 5: Start SOAPUI or Postman

POST request to 

    http://localhost:8181/cxf/xdto/NSI

Send test request:

    <soap:Envelope xmlns:soap="http://www.w3.org/2003/05/soap-envelope" xmlns:xdto="http://www.entaxy.ru/xdto_NSI">
       <soap:Header/>
       <soap:Body>
          <xdto:GetMDMReferences/>
       </soap:Body>
    </soap:Envelope>

Response contains GUID, copy it and send request for get result:

    <soap:Envelope xmlns:soap="http://www.w3.org/2003/05/soap-envelope" xmlns:xdto="http://www.entaxy.ru/xdto_NSI">
       <soap:Header/>
       <soap:Body>
          <xdto:GetResult>
             <xdto:RequestNumber>{GUID}</xdto:RequestNumber>
          </xdto:GetResult>
       </soap:Body>
    </soap:Envelope>

#### Step 6: Check the file system and DB
   Check the folder "target/inbox/" in the Karaf base directory to see that a message has arrived.

### Forum, Help, etc

If you hit an problems please let us know on the Camel Forums
	<http://camel.apache.org/discussion-forums.html>

Please help us make Apache Camel better - we appreciate any feedback you may
have.  Enjoy!


The Camel riders!



## Reinstall
    bin/karaf clean
    shell:source install.karaf


## Tests

<https://learning.getpostman.com/docs/postman/collection_runs/command_line_integration_with_newman/>

#### Install

    npm install -g newman

#### Run
    
    cd test
    newman run "Entaxy Integration Tests.postman_collection.json" -e "entaxy dev proxy.postman_environment.json"
    
or
    
    newman run "Entaxy Integration Tests.postman_collection.json" --env-var base_url=http://192.168.122.83:8181/cxf

#### CXF logging messages

    config:property-set -p org.apache.cxf.features.logging enabled true
    
and after restart bundle with cxf service
